"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantAnnotation(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_3 import opencb as opencb_2_9_3

        return {
            "additionalAttributes": opencb_2_9_3.AdditionalAttribute,
            "cancerHotspots": opencb_2_9_3.CancerHotspotVariantAnnotation,
            "consequenceTypes": opencb_2_9_3.ConsequenceType,
            "conservation": opencb_2_9_3.Score,
            "cytoband": opencb_2_9_3.Cytoband,
            "drugs": opencb_2_9_3.Drug,
            "functionalScore": opencb_2_9_3.Score,
            "geneCancerAssociations": opencb_2_9_3.GeneCancerAssociation,
            "geneConstraints": opencb_2_9_3.Constraint,
            "geneDrugInteraction": opencb_2_9_3.GeneDrugInteraction,
            "geneExpression": opencb_2_9_3.Expression,
            "geneMirnaTargets": opencb_2_9_3.GeneMirnaTarget,
            "geneTraitAssociation": opencb_2_9_3.GeneTraitAssociation,
            "gwas": opencb_2_9_3.GwasAssociation,
            "populationFrequencies": opencb_2_9_3.PopulationFrequency,
            "repeat": opencb_2_9_3.Repeat,
            "traitAssociation": opencb_2_9_3.EvidenceEntry,
            "xrefs": opencb_2_9_3.Xref,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_3 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.AdditionalAttribute": opencb_2_9_3.AdditionalAttribute,
            "org.opencb.biodata.models.variant.avro.CancerHotspotVariantAnnotation": opencb_2_9_3.CancerHotspotVariantAnnotation,
            "org.opencb.biodata.models.variant.avro.ConsequenceType": opencb_2_9_3.ConsequenceType,
            "org.opencb.biodata.models.variant.avro.Score": opencb_2_9_3.Score,
            "org.opencb.biodata.models.variant.avro.Cytoband": opencb_2_9_3.Cytoband,
            "org.opencb.biodata.models.variant.avro.Drug": opencb_2_9_3.Drug,
            "org.opencb.biodata.models.variant.avro.Score": opencb_2_9_3.Score,
            "org.opencb.biodata.models.variant.avro.GeneCancerAssociation": opencb_2_9_3.GeneCancerAssociation,
            "org.opencb.biodata.models.variant.avro.Constraint": opencb_2_9_3.Constraint,
            "org.opencb.biodata.models.variant.avro.GeneDrugInteraction": opencb_2_9_3.GeneDrugInteraction,
            "org.opencb.biodata.models.variant.avro.Expression": opencb_2_9_3.Expression,
            "org.opencb.biodata.models.variant.avro.GeneMirnaTarget": opencb_2_9_3.GeneMirnaTarget,
            "org.opencb.biodata.models.variant.avro.GeneTraitAssociation": opencb_2_9_3.GeneTraitAssociation,
            "org.opencb.biodata.models.variant.avro.GwasAssociation": opencb_2_9_3.GwasAssociation,
            "org.opencb.biodata.models.variant.avro.PopulationFrequency": opencb_2_9_3.PopulationFrequency,
            "org.opencb.biodata.models.variant.avro.Repeat": opencb_2_9_3.Repeat,
            "org.opencb.biodata.models.variant.avro.EvidenceEntry": opencb_2_9_3.EvidenceEntry,
            "org.opencb.biodata.models.variant.avro.Xref": opencb_2_9_3.Xref,
            "org.opencb.biodata.models.variant.avro.VariantAnnotation": opencb_2_9_3.VariantAnnotation,
        }

    __slots__ = [
        "additionalAttributes",
        "alternate",
        "ancestralAllele",
        "cancerHotspots",
        "chromosome",
        "consequenceTypes",
        "conservation",
        "cytoband",
        "displayConsequenceType",
        "drugs",
        "end",
        "functionalScore",
        "geneCancerAssociations",
        "geneConstraints",
        "geneDrugInteraction",
        "geneExpression",
        "geneMirnaTargets",
        "geneTraitAssociation",
        "gwas",
        "hgvs",
        "id",
        "minorAllele",
        "minorAlleleFreq",
        "populationFrequencies",
        "reference",
        "repeat",
        "start",
        "traitAssociation",
        "xrefs",
    ]

    def __init__(
        self,
        additionalAttributes=None,
        alternate=None,
        ancestralAllele=None,
        cancerHotspots=None,
        chromosome=None,
        consequenceTypes=list,
        conservation=None,
        cytoband=None,
        displayConsequenceType=None,
        drugs=None,
        end=None,
        functionalScore=None,
        geneCancerAssociations=None,
        geneConstraints=None,
        geneDrugInteraction=None,
        geneExpression=None,
        geneMirnaTargets=None,
        geneTraitAssociation=None,
        gwas=None,
        hgvs=None,
        id=None,
        minorAllele=None,
        minorAlleleFreq=None,
        populationFrequencies=None,
        reference=None,
        repeat=None,
        start=None,
        traitAssociation=None,
        xrefs=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.VariantAnnotation model.

        :param additionalAttributes:
        :type additionalAttributes: None | dict[str, AdditionalAttribute]
        :param alternate:
        :type alternate: None | str
        :param ancestralAllele:
        :type ancestralAllele: None | str
        :param cancerHotspots:
        :type cancerHotspots: None | list[CancerHotspotVariantAnnotation]
        :param chromosome:
        :type chromosome: None | str
        :param consequenceTypes:
        :type consequenceTypes: list[ConsequenceType]
        :param conservation:
        :type conservation: None | list[Score]
        :param cytoband:
        :type cytoband: None | list[Cytoband]
        :param displayConsequenceType:
        :type displayConsequenceType: None | str
        :param drugs:
        :type drugs: None | list[Drug]
        :param end:
        :type end: None | int
        :param functionalScore:
        :type functionalScore: None | list[Score]
        :param geneCancerAssociations:
        :type geneCancerAssociations: None | list[GeneCancerAssociation]
        :param geneConstraints:
        :type geneConstraints: None | list[Constraint]
        :param geneDrugInteraction:
        :type geneDrugInteraction: None | list[GeneDrugInteraction]
        :param geneExpression:
        :type geneExpression: None | list[Expression]
        :param geneMirnaTargets:
        :type geneMirnaTargets: None | list[GeneMirnaTarget]
        :param geneTraitAssociation:
        :type geneTraitAssociation: None | list[GeneTraitAssociation]
        :param gwas:
        :type gwas: None | list[GwasAssociation]
        :param hgvs:
        :type hgvs: None | list[str]
        :param id:
        :type id: None | str
        :param minorAllele:
        :type minorAllele: None | str
        :param minorAlleleFreq:
        :type minorAlleleFreq: None | float
        :param populationFrequencies:
        :type populationFrequencies: None | list[PopulationFrequency]
        :param reference:
        :type reference: None | str
        :param repeat:
        :type repeat: None | list[Repeat]
        :param start:
        :type start: None | int
        :param traitAssociation:
        :type traitAssociation: None | list[EvidenceEntry]
        :param xrefs:
        :type xrefs: None | list[Xref]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
